{Masodik raycasting nekifutas
         ami uj:
         -texturak
         -padlo
         -plafon
         meg egy kis atszervezes

         Akit csak a textura dolgok erdekelnek,
         azt a texture.ppi- ben talalja meg
}

Program Ray_Casting;

Uses Crt,Graph;

Const
       {A falakat felepito kockak 64*64*64 -esek lesznek}
       UNITSIZE=64;        {egy grid egyseg 64 kepzeletbeli kis egyseg}
       UNITSHIFT=6;        {2^6=64}
       HITDIST=32;         {ilyen kozel mehetunk egy falhoz}
       {egypar szogertek (360 helyett 2048-ra osztottuk fel a kort)}
       ANG_90=512;
       ANG_360=2048;
       ANG_0=0;
       ANG_180=1024;
       ANG_270=1536;
       {A szogfuggvenytablazatok ennyivel lesznek felszorozva}
       TABSHIFT=15;
       TABMUL=32768; {2^15}
       {latomezo 2048-as fokban (normalisan 60 fok)}
       FOV=340;
       {lekepezesi sik adatai}
       XMAX=319;
       YMAX=199;
       YHALF=100;
       XHALF=160;

Var
    screen : TScreen320X200;
    SinT,CosT,TanT,CtanT : array[0..ANG_360-1] of longint;
    Px,Py,AoV : longint;        {nezo adatai (hely, nezetszog)}
    AoRT : array[0..XMAX] of integer;    {Angle of Ray table}
    c : char;
    HeightScale : longint;      {lekepezeshez}

                {Egy par include}
{$i level.ppi}
{$i jascpal.ppi}
{$i texture.ppi}

Procedure FillTabs;
var i : integer;
    rad,a : real;
begin
      {szogfuggvenytablazatok}
      for i:=0 to ANG_360-1 do
      begin
            rad:=PI*i/ANG_180;
            SinT[i]:=trunc(TABMUL*sin(rad));
            CosT[i]:=trunc(TABMUL*cos(rad));
            if (i=ANG_90) or (i=ANG_270) then TanT[i]:=MaxInt*TABMUL
            else TanT[i]:=trunc(TABMUL*sin(rad)/cos(rad));
            if (i=ANG_0) or (i=ANG_180) then CtanT[i]:=MaxInt*TABMUL
            else CtanT[i]:=trunc(TABMUL*cos(rad)/sin(rad));
      end;

      {a sugar szoge minden kepernyooszlopra}
      for i:=0 to XMAX do
      begin
        a:=FOV/2-i*FOV/XMAX;
        AoRT[i]:=trunc(a);
      end;

      {HeightScale=UNITSIZE/160*tan(FOV/2)  TABSHIFT-el balra leptetve}
      HeightScale:=trunc(TABMUL*UNITSIZE*(XHALF*sin(2*PI*FOV/2048)/cos(2*PI*FOV/2048)));

      FillTexTabs(HeightScale);      {a texturazashoz a tablazatok. ld texture.ppi}
end;

{vizszintes fal keresese, tavolsag visszaadasa
 metszespont vX,vY-ba megy
 szemlelotol kiindulo sugar hol metsz egy vizszintes falat}

{            _____________
             |     |     |
             |___*vX,vY__|
             |   / |     |
             |__/__|_____|
             |*pX,pY     |
             |_____|_____|
}


function findXWall(var vX, vY : longint;a : integer) : integer;
var DeltaY, DeltaX, X, Y : longint;
    Grids : ^char;
begin
      findXwall:=MaxInt; {ha nincs fal, a leheto legnagyobb tavolsagot adjuk vissza}
      Grids:=@GridMap;
      {parhuzamos falakat nem metszhet a sugar}
      if (a=ANG_0) or (a=ANG_180) then exit;

      {felfele megy a sugar}
      if (a>ANG_0) and (a<ANG_180) then
      begin
            Y:=(vY and (-UNITSIZE))-1; {UNITSIZE 2 hatvanya kell hogy legyen!}
            DeltaY:=-UNITSIZE;
      end;
      {lefele megya sugar}
      if (a>ANG_180) and (a<ANG_360) then
      begin
            Y:=(vY and (-UNITSIZE))+UNITSIZE;{UNITSIZE 2 hatvanya kell hogy legyen!}
            DeltaY:=UNITSIZE;
      end;
      DeltaX:=-DeltaY*cTant[a];
      X:=(vX shl TABSHIFT)+(vY-Y)*ctanT[a];

      {rajta vagyunk-e a terkepen}
      if (X<0) or (X>=GRIDSIZE*TABMUL*UNITSIZE) or (Y<0) or (Y>=GRIDSIZE*UNITSIZE) then exit;

      while ((Grids+(Y and (-GRIDSIZE)) + (X shr (TABSHIFT+UNITSHIFT)))^=' ') do
      begin
            {lepeskozok hozzaadasa}
            X:=X+DeltaX;
            Y:=Y+DeltaY;
            {rajta vagyunk-e a terkepen}
            if (X<0) or (X>=GRIDSIZE*TABMUL*UNITSIZE) or (Y<0) or (Y>=GRIDSIZE*UNITSIZE) then exit;
      end;

      {tavolsag visszaadasa}
{      findXwall:=abs(((y-vY) shl TABSHIFT) div SinT[a]);}
      X:=X shr TABSHIFT;
      findXwall:=trunc(sqrt((x-vx)*(x-vx)+(y-vy)*(y-vy)));

      {falkoordinatak atadasa}
      vX:=X;
      vY:=Y;
end;

{fuggoleges fal keresese, tavolsag visszaadasa
 metszespont vX,vY-ba megy
 szemlelotol kiindulo sugar hol metsz egy fuggoleges falat}

{            _____________
             |     *vX,vY|
             |____/|_____|
             |   / |     |
             |__/__|_____|
             | *pX,pY    |
             |_____|_____|
}
function findYWall(var vX,vY : longint;a : integer) : integer;
var DeltaY, DeltaX, X, Y : longint;
    Grids : ^char;
begin
      findYWall:=MaxInt; {ha nincs fal, a leheto legnagyobb tavolsagot adjuk vissza}
      Grids:=@GridMap;

      {parhuzamos falakat nem metszhet a sugar}
      if (a=ANG_90) or (a=ANG_270) then exit;

      {jobbra megy a sugar}
      if (a<ANG_90) or (a>ANG_270) then
      begin
            X:=(vX and -UNITSIZE)+UNITSIZE;
            DeltaX:=UNITSIZE;
      end;
      {balra megy a sugar}
      if (a>ANG_90) and (a<ANG_270) then
      begin
            X:=(vX and -UNITSIZE)-1;
            DeltaX:=-UNITSIZE;
      end;

      {TABSHIFT -el balra tolt erteket kapunk (fixpontos szam)}
      Y:=(vY shl TABSHIFT)+(vX-X)*tanT[a];
      DeltaY:=-DeltaX*tanT[a];

      {ha kimentunk a palyarol, akkor biztos nincs fal}
      if (X<0) or (X>=GRIDSIZE*UNITSIZE) or (Y<0) or (Y>=GRIDSIZE*UNITSIZE*TABMUL) then exit;

      while ((Grids+((Y shr TABSHIFT) and -GRIDSIZE)+(X shr UNITSHIFT))^=' ') do
      begin
            {lepekozok}
            X:=X+DeltaX;
            Y:=Y+DeltaY;
            {ha kimentunk a palyarol, akkor biztos nincs fal}
            if (X<0) or (X>=GRIDSIZE*UNITSIZE) or (Y<0) or (Y>=GRIDSIZE*UNITSIZE*TABMUL) then exit;
      end;

      {A tavolsag visszaadasa}
{      findYwall:=abs((longint(x-vx) shl TABSHIFT) div CosT[a]);}
      y:=y shr TABSHIFT;
      findYwall:=trunc(sqrt((x-vx)*(x-vx)+(y-vy)*(y-vy)));

      {a fal koordinatainak atadasa}
      vY:=Y;
      vX:=X;
end;


{kepernyo felepitese}
{Hasznalt kulso valtozok : Aov - nezetszog Angle of View
                           pX,pY - nezo pozizioja (64-el felszorozva}
procedure BuildScreen;
var a,b,col : integer;
    Xdist, Ydist, dist : integer;
    U : integer;  {texture mappinghez}
    n : byte; {textura szama}
    Z : longint;
    H,StartY,EndY : integer;
    xX,yX,xY,yY : longint;
begin
    {oszloprol oszlopra}
    for col:=0 to 319 do
    begin
          {nezetszoghoz viszonyitott relativ szog}
          b:=AoRT[col] and (ANG_360-1);
          {abszolut szog}
          a:=(AoV+b) and (ANG_360-1);

          xX:=px;yX:=py;xY:=px;yY:=py;
          Xdist:=findXWall(xX,yX,a);
          Ydist:=findYWall(xY,yY,a);
          {A ket tavolsag kozul a kisebb kell}
          if Xdist<Ydist then
          begin
                dist:=Xdist;
                {texture mappinghez}
                U := xX and 63;
                U:=U+U; {Mivel 128X128 asak a texturak meg kell duplazni a koordinatat}
                {ha lefele nezunk tukrozzuk a texturat}
                if (a>ANG_180) and (a<ANG_360) then U:=127-U;
                n := ord(Gridmap[yX shr UNITSHIFT,xX  shr UNITSHIFT])-49;
          end
          else
          begin
                dist:=Ydist;
                {texture mappinghez}
                U := yY and 63;U:=U+U;
                if (a>ANG_90) and (a<ANG_270) then U:=127-U; {ha balra nezunk tukrozzuk a texturat}
                n := ord(GridMap[yY shr UNITSHIFT,xY shr UNITSHIFT])-49;
          end;


          {halszem korrekcio}
          Z:=abs(CosT[b]*dist);
          {magassagot kiszamoljuk}
          H:=(HeightScale div Z);

          {vonal kirajzolasa}
          StartY:=YHALF-(H shr 1);
          EndY:=YHALF+(H shr 1);
          WallTexLine(col,StartY,EndY,U,n);   {fal egy vonala}
          FloorCeilingTexLine(col,H,a,b,2,3);   {padlo es plafon egy vonala}
    end;
end;

{megenezzuk, hogy ralephetunk-e az adott helyre}
function CheckGrid(X, Y, A : integer) : boolean;
begin
      X:=X+(HITDIST*cost[A] div TABMUL);
      Y:=Y-(HITDIST*sint[A] div TABMUL);
      CheckGrid:=FALSE;
      {Nem mehetunk ki a palyarol}
      if (X<0) or (X>=GRIDSIZE*UNITSIZE) or (Y<0) or (Y>=GRIDSIZE*UNITSIZE) then exit;
      {Ha ures a hely, akkor jo}
      if GridMap[Y div UNITSIZE,X div UNITSIZE]=' ' then CheckGrid:=TRUE;
end;

begin
      FillTabs;
      readtextures('texlib2.raw');
      Init320X200;
      readpal('2.pal');
      Px:=UNITSIZE*BEGINGRIDX;
      Py:=UNITSIZE*BEGINGRIDY;
      AoV:=ANG_180;
      repeat
        BuildScreen;
        disp320X200(screen);
        fill320X200(screen,0);
        c:=readkey;
        if c=#0 then
        begin
                c:=readkey;
                case c of
                    #72 : begin  {fel}
                             if CheckGrid(Px+(cost[Aov] div 3000),Py-(sint[Aov] div 3000),Aov)
                             then begin
                                inc(Px,cost[Aov] div 3000);
                                dec(Py,sint[Aov] div 3000);
                             end;
                           end;
                    #80 : begin  {le}
                             if CheckGrid(Px-(cost[Aov] div 3000),Py+(sint[Aov] div 3000),Aov)
                             then begin
                                dec(Px,cost[Aov] div 3000);
                                inc(Py,sint[Aov] div 3000);
                             end;
                           end;
                    #75 : if CheckGrid(Px,Py,(AoV+24) and (ANG_360-1)) then {balra}
                             AoV:=(AoV+24) and (ANG_360-1);

                    #77 : if CheckGrid(Px,Py,(AoV-24) and (ANG_360-1)) then
                             AoV:=(Aov-24) and (ANG_360-1); {jobbra}
                end;
       end;
      until c=#27;      {ESC-re ki}

      CloseGraph;       {CSA}

End.